using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace UIMultiThread
{
	public partial class Form1 : Form
	{
		public delegate void ShowDelegate();
		private DataTable _dt;

		public Form1()
		{
			InitializeComponent();
		}

		
		private void Go()
		{
			_dt = new DataTable();
			_dt.Columns.Add(new DataColumn("Ime"));
			_dt.Columns.Add(new DataColumn("Prezime"));
			_dt.Columns.Add(new DataColumn("Adresa"));

			DataRow dr = _dt.NewRow();
			dr["ime"] = "Pera";
			dr["Prezime"] = "Zdera";
			dr["Adresa"] = "Prva";
			_dt.Rows.Add(dr);

			dr = _dt.NewRow();
			dr["ime"] = "Mile";
			dr["Prezime"] = "Milic";
			dr["Adresa"] = "Druga";
			_dt.Rows.Add(dr);

			dr = _dt.NewRow();
			dr["ime"] = "Jova";
			dr["Prezime"] = "Jovic";
			dr["Adresa"] = "Treca";
			_dt.Rows.Add(dr);

			long t = DateTime.Now.Ticks;
			while (true) 		
				if (DateTime.Now.Ticks - t > 50000000)
					break;
			

			dataGridView1.BeginInvoke(new ShowDelegate(ShowResult));
		}

		private void ShowResult()
		{
			dataGridView1.DataSource = _dt;
		}

		private void button1_Click(object sender, EventArgs e)
		{
			System.Threading.Thread tr = new System.Threading.Thread(new System.Threading.ThreadStart(Go));
			tr.Start();
		}
	}
}